.\" Copyright (c) 1997 Todd C. Miller <Todd.Miller@courtesan.com>
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgment:
.\"	This product includes software developed by Todd C. Miller.
.\" 4. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
.\" INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
.\" AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL
.\" THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
.\" EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
.\" PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
.\" OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
.\" WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
.\" OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
.\" ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\"	$OpenBSD: fsirand.8,v 1.6 1997/02/23 03:58:26 millert Exp $
.\" $FreeBSD: src/sbin/fsirand/fsirand.8,v 1.3.2.5 1999/09/05 11:23:57 peter Exp $
.\"
.Dd January 25, 1997
.Dt FSIRAND 8
.Os
.Sh NAME
.Nm fsirand
.Nd randomize inode generation numbers
.Sh SYNOPSIS
.Nm fsirand
.Op Fl b
.Op Fl f
.Op Fl p
.Ar special
.Op Ar "special ..."
.Sh DESCRIPTION
The
.Nm
command installs random generation numbers on all the inodes for
each filesystem specified on the command line by
.Ar special .
This increases the security of NFS-exported filesystems by making
it difficult to ``guess'' filehandles.
.Pp
.Em Note Ns :
.Xr newfs 8
now does the equivalent of
.Nm
itself so it is no longer necessary to
run
.Nm
by hand on a new filesystem.  It is only used to
re-randomize or report on an existing filesystem.
.Pp
.Nm Fsirand
should only be used on an unmounted filesystem that
has been checked with
.Xr fsck 8
or a filesystem that is mounted read-only.
.Nm Fsirand
may be used on the root filesystem in single-user mode
but the system should be rebooted via ``reboot -n'' afterwards.
.Sh OPTIONS
.Bl -tag -width indent
The available options are as follows:
.It Fl b
Use the default block size (usually 512 bytes) instead
of the value gleaned from the disklabel.
.It Fl f
Force
.Nm
to run even if the filesystem on
.Ar special
is not marked as clean.
.It Fl p
Print the current generation numbers for all inodes instead of
generating new ones.
.Sh CAVEATS
Since
.Nm
allocates enough memory to hold all the inodes in
a given cylinder group it may use a large amount
of memory for large disks with few cylinder groups.
.Sh SEE ALSO
.Xr fs 5 ,
.Xr fsck 8 ,
.Xr newfs 8
.Sh HISTORY
The
.Nm
command appeared in SunOS 3.x.
.br
This version of
.Nm
first appeared in
.Ox 2.1 .
A
.Bx Free
version first appeared in
.Fx 2.2.5 .
.Sh AUTHORS
.An Todd C. Miller Aq Todd.Miller@courtesan.com
